
/*********************************************************************************************/
/*                                                                                           */
/*********************************************************************************************/
#ifdef UNCO_FULL_TEAM

#include "../snes9x.h"
#include "../memmap.h"
#include "../ppu.h"
#include "../display.h"
#include "../apu.h"
#include "../soundux.h"

#include <time.h>

int BSXCHECK_XPP = FALSE;

void BSX_SRAMFIRST ()
{
  if(!BSXCHECK_XPP)
  {
    BSXCHECK_XPP=TRUE;
    BIOS_BSXBIOS_LOAD ();
    BIOS_BSXPSRAM_LOAD ();
    BIOS_BSXFONT_SET();
  }

  if (Memory.LoROM && Memory.ROM [0x7fd4] == 0)
  {
	Settings.Normalsnap = 1;
	S9xReset ();

    /* art@CA[Gu AJlCAL Pb pXח*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "pXח",10) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* art@CA[Gu AJlCAL Qb ԂRm*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "ԂRm",10) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* art@CA[Gu AJlCAL Rb `̓c*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "`̓c",12) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* art@CA[Gu AJlCAL Sb n܂̂Ƃ*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "n܂̂Ƃ",12) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* arj`uc*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "ϰެ",11) == 0) 
    {
           Memory.RAM [0x60E] = 18;
           Memory.RAM [0x60F] = 0;
    }
    else
    /* BS}[FX@BS F-ZERO SOUND LINK Ȃ pb`*/
    {
           Memory.RAM [0x1FFFF] = 0;
           Memory.RAM [0x1FFF9] = 18;
    }

  }
  /* BSX-Lo-rom End */

/* Hi-rom set */
  if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
  {

	Settings.Normalsnap = 1;
	S9xReset ();

    /* BS ZELDA RT pb`*/
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA", 8) == 0) ||
       (strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0))
    { 
           Memory.RAM [0x1FFFF] = 0;
           Memory.RAM [0x1FFF9] = 18;
    }
    else
    /* BS S@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
    { 
//        for (int i = 0; i < 0x20000; i++)
//        {
//           Memory.RAM [i] = 0xff;
//        }
    }
    else
    if (strncmp ((char *) &Memory.ROM [0xffc0], "̃Var", 16) == 0)
    {
           Memory.RAM [0x1FFFF] = 0;
           Memory.RAM [0x1FFF9] = 18;
    }
  }
}

void BSX_TIMESKIP ()
{

/* BSX-Lo-rom Set */
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

    /* art@CA[Gu AJlCAL Pb pXח@ԃXLbv*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "pXח",10) == 0)
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] +1;
    }
    else
    /* art@CA[Gu AJlCAL Qb ԂRm@ԃXLbv*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "ԂRm",10) == 0)  
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] +1;
    }
    else
    /* art@CA[Gu AJlCAL Rb `̓c@ԃXLbv*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "`̓c",12) == 0)
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] +1;
    }
    else
    /* art@CA[Gu AJlCAL Sb n܂̂Ƃ*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "n܂̂Ƃ",12) == 0)  
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] +1;
    }
    else
    /* arj`uc*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "ϰެ",11) == 0) 
    {
           Memory.RAM [0x60f] = Memory.RAM [0x60f] +1;
    }
    else
    /* BS}[FX@BS F-ZERO SOUND LINK Ȃ */
    {
           Memory.RAM [0x1FFFF] = Memory.RAM [0x1FFFF] +1;
    }

 }
 /* BSX-Lo-rom End */

/* Hi-rom set */
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

    /* BS Ty@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
    { 
             Memory.RAM [0x4183] = Memory.RAM [0x4183] +1;
    }
    else
    /* BS ZELDA RT */
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA", 8) == 0) ||
       (strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0))
    { 
            Memory.RAM [0x1FFFF] = Memory.RAM [0x1FFFF] +1;
    }
    else 
    /* BS S@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
    { 
             Memory.RAM [0x1740] = 0xff;
             Memory.RAM [0x1741] = 0xff;
             Memory.RAM [0x1744] = Memory.RAM [0x1744] +1;
    }
    else
    /* BS p[[@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BS Parlor(", 10) == 0)
    { 
             Memory.RAM [0xbcbc] = Memory.RAM [0xbcbc] +1;
    }
    else
    /* TEhW[i */
    if (strncmp ((char *) &Memory.ROM [0xffc0], "SJ Lovers Vol.2", 15) == 0) 
    { 
           Memory.RAM [0x92a] = Memory.RAM [0x92a] +1;
    }
    else
    /* TEhW[i */
    if (strncmp ((char *) &Memory.ROM [0xffc0], "޼ެ #4", 14) == 0) 
    { 
           Memory.RAM [0x843] = Memory.RAM [0x843] +1;
    }
    else
    if (strncmp ((char *) &Memory.ROM [0xffc0], "̃Var", 16) == 0)
    {
           Memory.RAM [0x1FFFF] = Memory.RAM [0x1FFFF] +1;
    }

 }

}

void BSX_TIMEBACK ()
{

/* BSX-Lo-rom Set */
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

    /* art@CA[Gu AJlCAL Pb pXח@ԃobN*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "pXח",10) == 0)
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] -1;
    }
    else
    /* art@CA[Gu AJlCAL Qb ԂRm@ԃobN*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "ԂRm",10) == 0)  
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] -1;
    }
    else
    /* art@CA[Gu AJlCAL Rb `̓c@ԃobN*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "`̓c",12) == 0)
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] -1;
    }
    else
    /* art@CA[Gu AJlCAL Sb n܂̂Ƃ*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "n܂̂Ƃ",12) == 0)  
    {
           Memory.RAM [0x1FFFa] = Memory.RAM [0x1FFFa] -1;
    }
    else
    /* arj`uc*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "ϰެ",11) == 0) 
    {
           Memory.RAM [0x60f] = Memory.RAM [0x60f] -1;
    }
    else
    /* BS}[FX@BS F-ZERO SOUND LINK Ȃ */
    {
           Memory.RAM [0x1FFFF] = Memory.RAM [0x1FFFF] -1;
    }

 }
 /* BSX-Lo-rom End */

/* Hi-rom set */
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

    /* BS Ty@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
    { 
             Memory.RAM [0x4183] = Memory.RAM [0x4183] -1;
    }
    else
    /* BS ZELDA RT */
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA", 8) == 0) ||
       (strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0))
    { 
            Memory.RAM [0x1FFFF] = Memory.RAM [0x1FFFF] -1;
    }
    else 
    /* BS S@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
    { 
             Memory.RAM [0x1740] = 0xff;
             Memory.RAM [0x1741] = 0xff;
             Memory.RAM [0x1744] = Memory.RAM [0x1744] -1;
    }
    else
    /* BS p[[@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BS Parlor(", 10) == 0)
    { 
             Memory.RAM [0xbcbc] = Memory.RAM [0xbcbc] -1;
    }
    else
    /* TEhW[i */
    if (strncmp ((char *) &Memory.ROM [0xffc0], "SJ Lovers Vol.2", 15) == 0) 
    { 
             Memory.RAM [0x92a] = Memory.RAM [0x92a] -1;
    }
    /* TEhW[i */
    if (strncmp ((char *) &Memory.ROM [0xffc0], "޼ެ #4", 14) == 0) 
    { 
           Memory.RAM [0x843] = Memory.RAM [0x843] -1;
    }
    else
    if (strncmp ((char *) &Memory.ROM [0xffc0], "̃Var", 16) == 0)
    {
           Memory.RAM [0x1FFFF] = Memory.RAM [0x1FFFF] -1;
    }

 }

}

void BSX_WORK ()
{

 /* BSX-Lo-rom Set */
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

 }
 /* BSX-Lo-rom End */

 /* Hi-rom set */
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

     /* BS Ty@pb`*/
     if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
     {
//         Memory.ROM [0x0EE78] = 0X09;
//         Memory.ROM [0x0EE79] = 0X75;
//         Memory.ROM [0x0EE7a] = 0XEA;

           Memory.RAM [0x4186] = 0x70;

     }
     /* END */

     /* BS S@pb`*/
//   if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
//   {
//         Memory.RAM [0x173D] = 18; 
//         Memory.RAM [0x1744] = 00;
//         Memory.RAM [0x1745] = 01;
//         Memory.RAM [0x1744] = Memory.RAM [0x1744] +2;
//   }
     /* END */

    /* BS ZELDA bZNg*/
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA PART1", 14) == 0) ||
        (strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDARb", 14) == 0)) 
    {
       if (Memory.ROM [0x5bc9b] == 00)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 2Weeks Mode");
            Memory.ROM [0x5bc9b]  = 01;
       } 
       else
       if (Memory.ROM [0x5bc9b] == 01)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 3Weeks Mode");
            Memory.ROM [0x5bc9b]  = 02;
       }
       else
       if (Memory.ROM [0x5bc9b] == 02)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 4Weeks Mode");
            Memory.ROM [0x5bc9b]  = 03;
       } 
       else
       if (Memory.ROM [0x5bc9b] == 03)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 1Weeks Mode");
            Memory.ROM [0x5bc9b]  = 00;
       }

    // Km|ÕtOɖ߂B
           Memory.SRAM [0x25a4]  = Memory.SRAM [0x25a6] = Memory.SRAM [0x25a7] = 0;
           Memory.SRAM [0x25b4]  = Memory.SRAM [0x25b6] = Memory.SRAM [0x25b7] = 0;
           Memory.SRAM [0x25c4]  = Memory.SRAM [0x25c6] = Memory.SRAM [0x25c7] = 0;
           Memory.SRAM [0x25d4]  = Memory.SRAM [0x25d6] = Memory.SRAM [0x25d7] = 0;

		S9xReset ();
       	BSX_TIMESET ();

    }
    /* END */

    /* BS ZELDA MAP 2 bZNg*/
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0) ||
        (strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA1      ", 15) == 0))
    {
       if (Memory.ROM [0x5bc9b] == 00)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 2Weeks Mode");
            Memory.ROM [0x5bc9b]  = 01;
       } 
       else
       if (Memory.ROM [0x5bc9b] == 01)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 3Weeks Mode");
            Memory.ROM [0x5bc9b]  = 02;
       }
       else
       if (Memory.ROM [0x5bc9b] == 02)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 4Weeks Mode");
            Memory.ROM [0x5bc9b]  = 03;
       } 
       else
       if (Memory.ROM [0x5bc9b] == 03)
       {
	     GFX.InfoStringTimeout = 100;
	     GFX.InfoString=("Bs Zelda 1Weeks Mode");
            Memory.ROM [0x5bc9b]  = 00;
       }

    // Km|ÕtOɖ߂B
        Memory.SRAM [0x25c8]  = Memory.SRAM [0x25ca] = Memory.SRAM [0x25cb] = 0;
        Memory.SRAM [0x25d8]  = Memory.SRAM [0x25da] = Memory.SRAM [0x25db] = 0;
        Memory.SRAM [0x25e8]  = Memory.SRAM [0x25ea] = Memory.SRAM [0x25eb] = 0;
        Memory.SRAM [0x25f8]  = Memory.SRAM [0x25fa] = Memory.SRAM [0x25fb] = 0;
        Memory.SRAM [0x263c] = 0;

		S9xReset ();
       	BSX_TIMESET ();

    }
    /* END */

 }
 /* Hi-rom End */

}

void BSX_WORKEXTRA ()
{

/* BSX-Lo-rom Set */
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

    /*ar[_̓` Ñ̐Δ ̃LN^[ύX@j*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "BS ",8) == 0) 
    { 
        if (!Xppbsx.Bszelda_Chr)
        Memory.SRAM [0x1c]  = Xppbsx.Bszelda_Chr = 1;
        else
        Memory.SRAM [0x1c]  = Xppbsx.Bszelda_Chr = 0;

		S9xReset ();
       	BSX_TIMESET ();
    }
    /* END */

 }
/* BSX-Lo-rom End */

/* Hi-rom set */
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

    /* BS ZELDA LN^[ύX@j*/
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA", 8) == 0) ||
       (strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0))
    { 
        if (!Xppbsx.Bszelda_Chr)
        Memory.SRAM [0x1c]  = Xppbsx.Bszelda_Chr = 1;
        else
        Memory.SRAM [0x1c]  = Xppbsx.Bszelda_Chr = 0;

		S9xReset ();
       	BSX_TIMESET ();
    }
    /* END */

    /* gW[RtNX@fobN[h@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "ڼެظ", 13) == 0)
    {
        if (Memory.ROM [0x7a7d] == 0xc7 && Memory.ROM [0x7a7e] == 0x59 && Memory.ROM [0x7a7f] == 0xc0 )
 	 {
 		Memory.ROM [0x7a7d] = 0x16; 
 		Memory.ROM [0x7a7e] = 0x72;
 		Memory.ROM [0x7a7f] = 0xc0;
		GFX.InfoStringTimeout = 100;
		GFX.InfoString=("T-C Opening Skip Mode Debug");
	 }
	 else 
 	 {
 		Memory.ROM [0x7a7d] = 0xc7; 
 		Memory.ROM [0x7a7e] = 0x59;
 		Memory.ROM [0x7a7f] = 0xc0;
		GFX.InfoStringTimeout = 100;
		GFX.InfoString=("T-C Opening Skip Mode Off");
	 }
    }
    /* END */

    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTyO", 16) == 0)
    { 
        int Bstan_Total_Time;
        Bstan_Total_Time = (Memory.RAM [0x4183]*60) + Memory.RAM [0x4184];

        if(Bstan_Total_Time < ((4*60)+8))
        {
            Memory.RAM [0x4183] = 4;
            Memory.RAM [0x4184] = 8;
        }
        else
        if(Bstan_Total_Time < ((6*60)+32))
        {
            Memory.RAM [0x4183] = 6;
            Memory.RAM [0x4184] = 32;
        }
        else
        if(Bstan_Total_Time < ((11*60)+39))
        {
            Memory.RAM [0x4183] = 11;
            Memory.RAM [0x4184] = 39;
        }
        else
        if(Bstan_Total_Time < ((12*60)+40))
        {
            Memory.RAM [0x4183] = 12;
            Memory.RAM [0x4184] = 40;
        }
        else
        if(Bstan_Total_Time < ((14*60)+47))
        {
            Memory.RAM [0x4183] = 14;
            Memory.RAM [0x4184] = 47;
        }
        else
        if(Bstan_Total_Time < ((24*60)+8))
        {
            Memory.RAM [0x4183] = 24;
            Memory.RAM [0x4184] = 8;
        }
        else
        if(Bstan_Total_Time < ((30*60)+0))
        {
            Memory.RAM [0x4183] = 30;
            Memory.RAM [0x4184] = 0;
        }
        else
        if(Bstan_Total_Time < ((37*60)+35))
        {
            Memory.RAM [0x4183] = 37;
            Memory.RAM [0x4184] = 35;
        }
        else
        if(Bstan_Total_Time < ((43*60)+47))
        {
            Memory.RAM [0x4183] = 43;
            Memory.RAM [0x4184] = 47;
        }
        else
        if(Bstan_Total_Time < ((46*60)+39))
        {
            Memory.RAM [0x4183] = 46;
            Memory.RAM [0x4184] = 39;
        }
        else
        if(Bstan_Total_Time < ((55*60)+17))
        {
            Memory.RAM [0x4183] = 55;
            Memory.RAM [0x4184] = 17;
        }
        else
        {
            Memory.RAM [0x4183] = 0;
            Memory.RAM [0x4184] = 0;
        }

        sprintf (String,"Set Time [%2d:%2d]",Memory.RAM [0x4183],Memory.RAM [0x4184]);
        S9xSetInfoString (String);
        GFX.InfoStringTimeout = 100;
    }

    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 16) == 0)
    { 
        int Bstan_Total_Time;
        Bstan_Total_Time = (Memory.RAM [0x4183]*60) + Memory.RAM [0x4184];

        if(Bstan_Total_Time < ((4*60)+8))
        {
            Memory.RAM [0x4183] = 4;
            Memory.RAM [0x4184] = 8;
        }
        else
        if(Bstan_Total_Time < ((9*60)+41))
        {
            Memory.RAM [0x4183] = 9;
            Memory.RAM [0x4184] = 41;
        }
        else
        if(Bstan_Total_Time < ((10*60)+24))
        {
            Memory.RAM [0x4183] = 10;
            Memory.RAM [0x4184] = 24;
        }
        else
        if(Bstan_Total_Time < ((16*60)+3))
        {
            Memory.RAM [0x4183] = 16;
            Memory.RAM [0x4184] = 3;
        }
        else
        if(Bstan_Total_Time < ((18*60)+7))
        {
            Memory.RAM [0x4183] = 18;
            Memory.RAM [0x4184] = 7;
        }
        else
        if(Bstan_Total_Time < ((22*60)+24))
        {
            Memory.RAM [0x4183] = 22;
            Memory.RAM [0x4184] = 24;
        }
        else
        if(Bstan_Total_Time < ((24*60)+6))
        {
            Memory.RAM [0x4183] = 24;
            Memory.RAM [0x4184] = 6;
        }
        else
        if(Bstan_Total_Time < ((25*60)+5))
        {
            Memory.RAM [0x4183] = 25;
            Memory.RAM [0x4184] = 5;
        }
        else
        if(Bstan_Total_Time < ((29*60)+30))
        {
            Memory.RAM [0x4183] = 29;
            Memory.RAM [0x4184] = 30;
        }
        else
        if(Bstan_Total_Time < ((34*60)+19))
        {
            Memory.RAM [0x4183] = 34;
            Memory.RAM [0x4184] = 19;
        }
        else
        if(Bstan_Total_Time < ((39*60)+2))
        {
            Memory.RAM [0x4183] = 39;
            Memory.RAM [0x4184] = 2;
        }
        else
        if(Bstan_Total_Time < ((44*60)+6))
        {
            Memory.RAM [0x4183] = 44;
            Memory.RAM [0x4184] = 6;
        }
        else
        if(Bstan_Total_Time < ((47*60)+33))
        {
            Memory.RAM [0x4183] = 47;
            Memory.RAM [0x4184] = 33;
        }
        else
        if(Bstan_Total_Time < ((55*60)+25))
        {
            Memory.RAM [0x4183] = 55;
            Memory.RAM [0x4184] = 25;
        }
        else
        {
            Memory.RAM [0x4183] = 0;
            Memory.RAM [0x4184] = 0;
        }

        sprintf (String,"Set Time [%2d:%2d]",Memory.RAM [0x4183],Memory.RAM [0x4184]);
        S9xSetInfoString (String);
        GFX.InfoStringTimeout = 100;
    }

    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 16) == 0)
    { 
        int Bstan_Total_Time;
        Bstan_Total_Time = (Memory.RAM [0x4183]*60) + Memory.RAM [0x4184];

        if(Bstan_Total_Time < ((4*60)+8))
        {
            Memory.RAM [0x4183] = 4;
            Memory.RAM [0x4184] = 8;
        }
        else
        if(Bstan_Total_Time < ((11*60)+26))
        {
            Memory.RAM [0x4183] = 11;
            Memory.RAM [0x4184] = 26;
        }
        else
        if(Bstan_Total_Time < ((12*60)+9))
        {
            Memory.RAM [0x4183] = 12;
            Memory.RAM [0x4184] = 9;
        }
        else
        if(Bstan_Total_Time < ((20*60)+40))
        {
            Memory.RAM [0x4183] = 20;
            Memory.RAM [0x4184] = 40;
        }
        else
        if(Bstan_Total_Time < ((26*60)+22))
        {
            Memory.RAM [0x4183] = 26;
            Memory.RAM [0x4184] = 22;
        }
        else
        if(Bstan_Total_Time < ((31*60)+42))
        {
            Memory.RAM [0x4183] = 31;
            Memory.RAM [0x4184] = 42;
        }
        else
        if(Bstan_Total_Time < ((37*60)+54))
        {
            Memory.RAM [0x4183] = 37;
            Memory.RAM [0x4184] = 54;
        }
        else
        if(Bstan_Total_Time < ((40*60)+41))
        {
            Memory.RAM [0x4183] = 40;
            Memory.RAM [0x4184] = 41;
        }
        else
        if(Bstan_Total_Time < ((52*60)+43))
        {
            Memory.RAM [0x4183] = 52;
            Memory.RAM [0x4184] = 43;
        }
        else
        {
            Memory.RAM [0x4183] = 0;
            Memory.RAM [0x4184] = 0;
        }

        sprintf (String,"Set Time [%2d:%2d]",Memory.RAM [0x4183],Memory.RAM [0x4184]);
        S9xSetInfoString (String);
        GFX.InfoStringTimeout = 100;
    }

 }
 /* Hi-rom End */

}

void BSX_TIMESET ()
{

/* BSX-Lo-rom Set */
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {
	S9xReset ();

    /* art@CA[Gu AJlCAL Pb pXח*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "pXח",10) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* art@CA[Gu AJlCAL Qb ԂRm*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "ԂRm",10) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* art@CA[Gu AJlCAL Rb `̓c*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "`̓c",12) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* art@CA[Gu AJlCAL Sb n܂̂Ƃ*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "n܂̂Ƃ",12) == 0) 
    {
           Memory.RAM [0x1FFFa] = 0;
           Memory.RAM [0x1FFFb] = 18;
    }
    else
    /* arj`uc*/
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "ϰެ",11) == 0) 
    {
           Memory.RAM [0x60E] = 18;
           Memory.RAM [0x60F] = 0;
    }
    else
    /* BS}[FX@BS F-ZERO SOUND LINK Ȃ pb`*/
    {
           Memory.RAM [0x1FFFF] = 0;
           Memory.RAM [0x1FFF9] = 18;
    }

 }
 /* BSX-Lo-rom End */

/* Hi-rom set */
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {
	S9xReset ();

    /* BS ZELDA RT pb`*/
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA", 8) == 0) ||
       (strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0))
    { 
           Memory.RAM [0x1FFFF] = 0;
           Memory.RAM [0x1FFF9] = 18;
    }
    else
    /* BS Ty@pb`*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
    {
//     Memory.ROM [0x0EE78] = 0Xad;
//     Memory.ROM [0x0EE79] = 0X86;
//     Memory.ROM [0x0EE7a] = 0X41;
    }
    else
    /* BS S@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
    { 
//       for (int i = 0; i < 0x20000; i++)
//       {
//          Memory.RAM [i] = 0xff;
//       }
    }
    else
    if (strncmp ((char *) &Memory.ROM [0xffc0], "̃Var", 16) == 0)
    {
           Memory.RAM [0x1FFFF] = 0;
           Memory.RAM [0x1FFF9] = 18;
    }

 }
 /* Hi-rom End */

}


void BSX_WATCHTIME ()
{

/* BSX-Lo-rom Set */
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

    /* art@CA[Gu AJlCAL Pb pXח@ԃXLbv*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "pXח",10) == 0)
    {
           Xppbsx.Bssound_Time= Memory.RAM [0x1FFFa];
    }
    else
    /* art@CA[Gu AJlCAL Qb ԂRm@ԃXLbv*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "ԂRm",10) == 0)  
    {
           Xppbsx.Bssound_Time= Memory.RAM [0x1FFFa];
    }
    else
    /* art@CA[Gu AJlCAL Rb `̓c@ԃXLbv*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "`̓c",12) == 0)
    {
           Xppbsx.Bssound_Time= Memory.RAM [0x1FFFa];
    }
    else
    /* art@CA[Gu AJlCAL Sb n܂̂Ƃ*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "n܂̂Ƃ",12) == 0)  
    {
           Xppbsx.Bssound_Time= Memory.RAM [0x1FFFa];
    }
    else
    /* arj`uc*/
        if (strncmp ((char *) &Memory.ROM [0x7fc0], "ϰެ",11) == 0) 
    {
           Xppbsx.Bssound_Time= Memory.RAM [0x60f];
    }
    else
    /* BS}[FX@BS F-ZERO SOUND LINK Ȃ */
    {
           Xppbsx.Bssound_Time= Memory.RAM [0x1FFFF];
    }

 }
 /* BSX-Lo-rom End */

 /* Hi-rom set */
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

    /* BS Ty@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
    { 
             Xppbsx.Bssound_Time= Memory.RAM [0x4183];
    }
    else
    /* BS ZELDA RT */
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA", 8) == 0) ||
       (strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0))
    { 
             Xppbsx.Bssound_Time= Memory.RAM [0x1FFFF];
    }
    else 
    /* BS S@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
    { 
             Xppbsx.Bssound_Time= Memory.RAM [0x1744];
    }
    else
    /* BS p[[@*/
    if (strncmp ((char *) &Memory.ROM [0xffc0], "BS Parlor(", 10) == 0)
    { 
             Xppbsx.Bssound_Time= Memory.RAM [0xbcbc];
    }
    else
    /* TEhW[i */
    if (strncmp ((char *) &Memory.ROM [0xffc0], "SJ Lovers Vol.2", 15) == 0) 
    { 
             Xppbsx.Bssound_Time= Memory.RAM [0x92a];
    }
    /* TEhW[i */
    if (strncmp ((char *) &Memory.ROM [0xffc0], "޼ެ #4", 14) == 0) 
    { 
             Xppbsx.Bssound_Time= Memory.RAM [0x843];
    }
    else
    if (strncmp ((char *) &Memory.ROM [0xffc0], "̃Var", 16) == 0)
    {
             Xppbsx.Bssound_Time= Memory.RAM [0x1FFFF];
    }

 }

}

void BSX_MEMORYFIX ()
{

    /* Lo-rom n tF ar}[FXȂǁEE*/
      time_t current_time;
      struct tm *t;
      struct tm the_time;
      current_time = time(NULL);
      t = localtime(&current_time);
      the_time = *t;

    if (strncmp ((char *) &Memory.ROM [0x7fc0], "BS ϰ", 5) == 0)
    {
       Memory.RAM [0x1fff1]  = the_time.tm_mon+1;
       Memory.RAM [0x1fff2]  = the_time.tm_mday;
    }
    /* end */

    /* Fix Bs Zelda Ñ̐Δ LN^[pbgC */
    if (strncmp ((char *) &Memory.ROM [0x7fc0], "BS ",8) == 0) 
    { 
        if (Memory.SRAM [0x1c] >= 0x2)
        Memory.SRAM [0x1c]  = Xppbsx.Bszelda_Chr;
    } 

    /* BS ZELDA RTځ@57ɂȂƎIɎ̘bɍs悤ɂ */
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA PART1", 14) == 0) ||
        (strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDARb", 14) == 0)) 
    { 
        if (Memory.RAM [0x1ffff]==57)
        {
           if (Memory.ROM [0x5bc9b] == 00)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Next Week - Bs Zelda 2Weeks");
              Memory.ROM [0x5bc9b]  = 01;
           } 
           else
           if (Memory.ROM [0x5bc9b] == 01)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Next Week - Bs Zelda 3Weeks");
              Memory.ROM [0x5bc9b]  = 02;
           }
           else
           if (Memory.ROM [0x5bc9b] == 02)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Next Week - Bs Zelda 4Weeks");
              Memory.ROM [0x5bc9b]  = 03;
           } 
           else
           if (Memory.ROM [0x5bc9b] == 03)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Retry - Bs Zelda 4Weeks");
              Memory.ROM [0x5bc9b]  = 03;
           }

          // Km|ÕtOɖ߂B
           Memory.SRAM [0x25a4]  = Memory.SRAM [0x25a6] = Memory.SRAM [0x25a7] = 0;
           Memory.SRAM [0x25b4]  = Memory.SRAM [0x25b6] = Memory.SRAM [0x25b7] = 0;
           Memory.SRAM [0x25c4]  = Memory.SRAM [0x25c6] = Memory.SRAM [0x25c7] = 0;
           Memory.SRAM [0x25d4]  = Memory.SRAM [0x25d6] = Memory.SRAM [0x25d7] = 0;

	    S9xReset ();
           BSX_TIMESET ();
        }
    }
    /* END */

    /* BS ZELDA MAP2 RTځ@57ɂȂƎIɎ̘bɍs悤ɂ */
    if ((strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0) ||
        (strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA1      ", 15) == 0))
    { 
        if (Memory.RAM [0x1ffff]==57)
        {
           if (Memory.ROM [0x5bc9b] == 00)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Next Week - Bs Zelda 2Weeks");
              Memory.ROM [0x5bc9b]  = 01;
           } 
           else
           if (Memory.ROM [0x5bc9b] == 01)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Next Week - Bs Zelda 3Weeks");
              Memory.ROM [0x5bc9b]  = 02;
           }
           else
           if (Memory.ROM [0x5bc9b] == 02)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Next Week - Bs Zelda 4Weeks");
              Memory.ROM [0x5bc9b]  = 03;
           } 
           else
           if (Memory.ROM [0x5bc9b] == 03)
           {
	       GFX.InfoStringTimeout = 100;
	       GFX.InfoString=("Retry - Bs Zelda 4Weeks");
              Memory.ROM [0x5bc9b]  = 03;
           }

          // Km|ÕtOɖ߂B
        Memory.SRAM [0x25c8]  = Memory.SRAM [0x25ca] = Memory.SRAM [0x25cb] = 0;
        Memory.SRAM [0x25d8]  = Memory.SRAM [0x25da] = Memory.SRAM [0x25db] = 0;
        Memory.SRAM [0x25e8]  = Memory.SRAM [0x25ea] = Memory.SRAM [0x25eb] = 0;
        Memory.SRAM [0x25f8]  = Memory.SRAM [0x25fa] = Memory.SRAM [0x25fb] = 0;
        Memory.SRAM [0x263c] = 0;

	    S9xReset ();
           BSX_TIMESET ();
        }
    }
    /* END */

    BSX_WATCHTIME ();


}

/*********************************************************************************************/
/*                                                                                           */
/*********************************************************************************************/


void BSX_CLEAR ()
{
         BSXCHECK_XPP=0;
         Xppcdda.Soundlink_cd_track = 0;
         Xppcdda.Sound_SyncSpeed = 0;

         Xppbsx.Bszelda_Chr = 0;
         Xppbsx.Bssound_Time = 0;
}

/*********************************************************************************************/
/* ROMBSSETEXTRA                                                                               */
/*********************************************************************************************/

void ROMBSSETEXTRA ()
{
/* BSXn\tgTCN̐ݒ */
    Settings.H_Max = (100 * SNES_CYCLES_PER_SCANLINE) / 108;

/* 0x22 0x08 0x5C 0x10p̃pb`*/
      for (int i = 0; i < 0x100000; i++)
      {
            if(ROM [i]==0x22 && ROM [i+1]==0x08 && ROM [i+2]==0x5C && ROM [i+3]==0x10)
            {
                  ROM [i] = ROM [i+1] = ROM [i+2] = ROM [i+3] = 0xEA;
            }
      }

/* BSX Ή[` HiRom*/
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

      if ((strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA PART1", 14) == 0) ||
          (strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDARb", 14) == 0)) 
      {
             ROM [0x5c20d] = 0xff; /**/
             ROM [0x5c211] = 0xff;

             ROM [0x5bc9b] = 0x00; /*b*/

      }

     if ((strncmp ((char *) &Memory.ROM [0xffc0], "BSނ̓`Q", 15) == 0) ||
         (strncmp ((char *) &Memory.ROM [0xffc0], "BS ZELDA1      ", 15) == 0))
      {
             ROM [0x5c240] = 0xff; /**/
             ROM [0x5c244] = 0xff;

             ROM [0x5bc9b] = 0x00; /*b*/

      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
      {
//           ROM [0x0EE78] = 0X09;
//           ROM [0x0EE79] = 0X75;
//           ROM [0x0EE7a] = 0XEA;
             Settings.H_Max = (95 * SNES_CYCLES_PER_SCANLINE) / 100;
      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
      {
          /* WORKING PATCH */
             ROM [0x005C5] = 0xE2;
             ROM [0x005C6] = 0x20;
             ROM [0x005C7] = 0xA9;
             ROM [0x005C8] = 0x12;
             ROM [0x005C9] = 0x8f;
             ROM [0x005CA] = 0x3D;
             ROM [0x005CB] = 0x17;
             ROM [0x005CC] = 0x00;
             ROM [0x005CD] = 0xC2;
             ROM [0x005CE] = 0x20;
             ROM [0x005D2] = 0xEA;
             ROM [0x005D3] = 0xEA;
             ROM [0x005D7] = 0xEA;
             ROM [0x005D8] = 0xEA;
             ROM [0x02B42] = 0x70;
             ROM [0x02B4B] = 0x70;
             ROM [0x02B4F] = 0x73;
             ROM [0x02B56] = 0x70;
             ROM [0x02B5A] = 0x73;

             IAPU.OneCycle = 16;
      }
 
      if (strncmp ((char *) &Memory.ROM [0xffc0], "ڼެظ", 13) == 0)
      {
           /* Bsx Sram Ήpb`*/
    //         ROM [0x05a13] = ROM [0x05a19] = 0xea;
    //         ROM [0x05a14] = ROM [0x05a1a] = 0xea;
    //         ROM [0x05a15] = ROM [0x05a1b] = 0xea;
    //         ROM [0x05a16] = ROM [0x05a1c] = 0xea;
               ROM [0x0ffb5] = 0;
    //           CPU.MAX_NTSC_VCOUNTER = 265;

          Settings.H_Max = (100 * SNES_CYCLES_PER_SCANLINE) / 100;
      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "׼޶٥ذϰ", 14) == 0)
      {
           /* XɂǂISRAMȂ悤ɂ镔*/
             ROM [0x0e0b2] = 0xa0;
             ROM [0x0e0b3] = 0xff;
             ROM [0x0e0b4] = 0x00;

          Settings.H_Max = (100 * SNES_CYCLES_PER_SCANLINE) / 108;
      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "޲ϲڰ", 12) == 0)
          Settings.H_Max = (100 * SNES_CYCLES_PER_SCANLINE) / 108;

      if (Memory.HiROM && strncmp ((char *) &Memory.ROM [0xffc0], "SJ Lovers Vol.2", 15) == 0) 
          Options.RAMInitialValue = 0x00;

 }

/* BSX Ή[` LoRom*/
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

      /* J[rB̂ᔠ */
      if (strcmp (Memory.ROMName, "邮{[") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "x[X{[") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "ިްް") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "AW{[") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "Lm{[") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "ިݺ") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;

      if (strcmp (Memory.ROMName, "s{[") == 0)
          Settings.H_Max = (195 * SNES_CYCLES_PER_SCANLINE) / 100;
      /* end */
 }

}

/*********************************************************************************************/
/* ROMBSFONTEXTRA                                                                               */
/*********************************************************************************************/

void ROMBSFONTEXTRA ()
{

/* BS FONTΉ[` HiRom*/
 if (Memory.HiROM && Memory.ROM [0xffd4] == 0)
 {

      if (strncmp ((char *) &Memory.ROM [0xffc0], "BSTy", 14) == 0)
      {
             ROM [0x0F739] = 0x39;
             ROM [0x0F73F] = 0x39;
             ROM [0x0F745] = 0x39;
             ROM [0x0F74B] = 0x39;
             ROM [0x0F751] = 0x39;
             ROM [0x0F757] = 0x39;
             ROM [0x0F75D] = 0x3a;
             ROM [0x0F763] = 0x3b;
             ROM [0x0F769] = 0x3c;
             ROM [0x0F76F] = 0x3c;
             ROM [0x0F775] = 0x3d;
             ROM [0x0F77b] = 0x3d;
             ROM [0x0F781] = 0x3e;
             ROM [0x0F787] = 0x3f;
      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "arVES", 14) == 0)
      {
             ROM [0x02971] = 0x39;
             ROM [0x02979] = 0x39;
             ROM [0x02981] = 0x39;
             ROM [0x02989] = 0x39;
             ROM [0x02991] = 0x39;
             ROM [0x02999] = 0x39;
             ROM [0x029a1] = 0x3a;
             ROM [0x029a9] = 0x3b;
             ROM [0x029b1] = 0x3c;
             ROM [0x029b9] = 0x3c;
             ROM [0x029c1] = 0x3d;
             ROM [0x029c9] = 0x3d;
             ROM [0x029d1] = 0x3e;
             ROM [0x029d9] = 0x3f;
      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "ڼެظ", 13) == 0)
      {
             ROM [0x05d0c] = 0x39;
             ROM [0x05d1c] = 0x39;
             ROM [0x05d2c] = 0x39;
             ROM [0x05d3c] = 0x3a;
             ROM [0x05d4c] = 0x3c;
             ROM [0x05d5c] = 0x3d;
             ROM [0x05d6c] = 0x3e;
             ROM [0x05d14] = 0x39;
             ROM [0x05d24] = 0x39;
             ROM [0x05d34] = 0x39;
             ROM [0x05d44] = 0x3b;
             ROM [0x05d54] = 0x3c;
             ROM [0x05d64] = 0x3d;
             ROM [0x05d74] = 0x3f;
      }

      if (strncmp ((char *) &Memory.ROM [0xffc0], "׼޶٥ذϰ", 14) == 0)
      {
             ROM [0x0a471] = 0x39;
             ROM [0x0a478] = 0x39;
             ROM [0x0a47f] = 0x39;
             ROM [0x0a486] = 0x39;
             ROM [0x0a48d] = 0x39;
             ROM [0x0a494] = 0x39;
             ROM [0x0a49b] = 0x3a;
             ROM [0x0a4a2] = 0x3b;
             ROM [0x0a4a9] = 0x3c;
             ROM [0x0a4b0] = 0x3c;
             ROM [0x0a4b7] = 0x3d;
             ROM [0x0a4be] = 0x3d;
             ROM [0x0a4c5] = 0x3e;
             ROM [0x0a4cc] = 0x3f;
      }

      if ((strncmp ((char *) &Memory.ROM [0xffc0], "޼ެ #4", 14) == 0))
      {
             ROM [0x0d0d6] = 0x39;
      }

      /* 8M}KWFontΉpb`*/
      if  (Memory.ROM [0xd0d6] == 0x89)
           ROM [0x0d0d6] = 0x39; 
 }

/* BS FONTΉ[` LoRom*/
 if (Memory.LoROM && ROM [0x7fd4] == 0)
 {

      if (strcmp (Memory.ROMName, "ϰެ") == 0)
      {
             ROM [0xd0bb0] = 0x60;
             ROM [0xd0bc0] = 0x60;
             ROM [0xd0bd0] = 0x60;
             ROM [0xd0be0] = 0x61;
             ROM [0xd0bf0] = 0x63;
             ROM [0xd0c00] = 0x64;
             ROM [0xd0c10] = 0x65;
             ROM [0xd0bb8] = 0x60;
             ROM [0xd0bc8] = 0x60;
             ROM [0xd0bd8] = 0x60;
             ROM [0xd0be8] = 0x62;
             ROM [0xd0bf8] = 0x63;
             ROM [0xd0c08] = 0x64;
             ROM [0xd0c18] = 0x66;
      }

      if (strncmp ((char *) &Memory.ROM [0x7fc0], "BS ̧В",8) == 0) 
      {
             ROM [0x076ef] = 0x60;
             ROM [0x076f7] = 0x60;
             ROM [0x076ff] = 0x60;
             ROM [0x07707] = 0x60;
             ROM [0x0770f] = 0x60;
             ROM [0x07717] = 0x60;
             ROM [0x0771f] = 0x61;
             ROM [0x07727] = 0x62;
             ROM [0x0772f] = 0x63;
             ROM [0x07737] = 0x63;
             ROM [0x0773f] = 0x64;
             ROM [0x07747] = 0x64;
             ROM [0x0774f] = 0x65;
             ROM [0x07757] = 0x66;
      }
 }

}

/* 啔BSXŎ~܂镔́@22 08 5C 10̕łBׂEAɂΓ悤ɂȂ͂łB*/
#endif
