#include <windows.h>

//{Ήstrrchr()
LPSTR StrRChrDBCS(LPSTR pSrc,char ch)
{
    LPSTR pHit = NULL;      // Set search error

    for ( ; *pSrc; pSrc++) {
        if (IsDBCSLeadByte(*pSrc)) {
            pSrc++;
            continue;
        }
        if (*pSrc == ch) {
            pHit = pSrc;
        }
    }
    return pHit;
}

//  V[gt@C烍Ot@C̎擾
BOOL  GetLongFileName( LPCTSTR lpszShortFileName, LPTSTR lpszBuffer, DWORD dwBufferSize )
{
    WIN32_FIND_DATA  wfd;
    HANDLE  hFind;
    char  szTmpShortFile[MAX_PATH];
    char  szLongFile[MAX_PATH];
    char  szTmp[MAX_PATH];
    LPTSTR  lpYen;
    int  nPos;

    szLongFile[0] = '\0';
    lstrcpy( szTmpShortFile, lpszShortFileName );

    hFind = FindFirstFile( szTmpShortFile, &wfd );
    if (hFind == INVALID_HANDLE_VALUE) {
        return FALSE;
    }
    FindClose(hFind);

    do
    {
        // SpR[hɁu\ṽAXL[R[h܂܂Ăꍇɕs̂
        // L̊֐ǉ
        lpYen = StrRChrDBCS( szTmpShortFile, '\\' );
        if( lpYen != NULL )
        {
            nPos = lpYen - szTmpShortFile;
            if( lstrlen(szLongFile) == 0 )
                lstrcpy( szLongFile, wfd.cFileName );
            else
            {
                wsprintf( szTmp, "%s\\%s", wfd.cFileName, szLongFile );
                lstrcpy( szLongFile, szTmp );
            }
            szTmpShortFile[nPos] = '\0';
            hFind = FindFirstFile( szTmpShortFile ,&wfd );
            if (hFind == INVALID_HANDLE_VALUE) {
                // ̏ǉ΃lbg[Ñt@Cϊł܂
                wsprintf( szTmp, "%s\\%s", szTmpShortFile, szLongFile );
                lstrcpy( szLongFile, szTmp );
                break;
            }
            FindClose(hFind);
        }
        else
        {
            wsprintf( szTmp, "%s\\%s", szTmpShortFile, szLongFile );
            lstrcpy( szLongFile, szTmp );
        }
    } while( lpYen != NULL );

    if( (DWORD)lstrlen(szLongFile) >= dwBufferSize )
        return FALSE;

    lstrcpy( lpszBuffer, szLongFile );
    return TRUE;
}

POINT *GetWindowPosCenter(long wW, long wH)
{
	static POINT pt;
	RECT rcWork;
	SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWork, 0);
	/* EChEƗ̈Ɏ܂ꍇ */
	if(wW <= (rcWork.right - rcWork.left)
		&& wH <= (rcWork.bottom - rcWork.top)) {
		pt.x = rcWork.left + (((rcWork.right - rcWork.left) - wW) / 2);
		pt.y = rcWork.top + (((rcWork.bottom - rcWork.top) - wH) / 2);
		return &pt;
	}
	/* EChEƗ̈Ɏ܂Ȃꍇ */
	else if(wW > (rcWork.right - rcWork.left)
		&& wH > (rcWork.bottom - rcWork.top)) {
		pt.x = rcWork.left;
		pt.y = rcWork.top;
		return &pt;
	}
	else if(wW > (rcWork.right - rcWork.left)) {
		pt.x = rcWork.left;
		pt.y = rcWork.top + (((rcWork.bottom - rcWork.top) - wH) / 2);
		return &pt;
	}
	else {
		pt.x = rcWork.left + (((rcWork.right - rcWork.left) - wW) / 2);
		pt.y = rcWork.top;
		return &pt;
	}
}

//IMELA֐
BOOL WINAPI ImeEnable(HWND hwnd, BOOL fEnable)
{
	static HINSTANCE hwinnls;
	static BOOL (WINAPI *WINNLSEnableIME)(HWND,BOOL);
	BOOL retresult;
	if(hwinnls == NULL) {
		hwinnls = LoadLibrary("WINNLS32.DLL");
		if(hwinnls)
			WINNLSEnableIME = (BOOL (WINAPI *)(HWND,BOOL))GetProcAddress((HMODULE)hwinnls, "WINNLS32EnableIME");
	}
	if(WINNLSEnableIME)
		retresult = WINNLSEnableIME(hwnd, fEnable);
	else
		retresult = TRUE;
	if(hwinnls) {
		FreeLibrary(hwinnls);
		hwinnls = NULL;
		WINNLSEnableIME = NULL;
	}
	return retresult;
}
