/* Render.h
 * ----------
 * This file contains all the prototypes, structers and variables used and defined by Render.cpp
 */

struct SSurface {
	unsigned char *Surface;

	unsigned int Pitch;
	unsigned int Width;
	unsigned int Height;
};

extern void SelectRenderingCodes();
extern void (*SelectRenderMethod)();
extern void (*SelectRenderMethodd)();
extern void ResetRenderMethod();
typedef void (*TRenderMethod)( SSurface Src, SSurface Dst, RECT *srcRect);
typedef unsigned char (*TRenderMethodd)( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" TRenderMethod RenderMethod;
extern "C" TRenderMethodd RenderMethodd;
extern "C" unsigned char ExtendHeight, ExtendHeight_bak, DoubleHeight, DoubleWidth;
extern "C" TRenderMethodd ConvertDepth;
