#include "../snes9x/snes9x.h"
#include "../snes9x/ppu.h"
#include <stdio.h>
#include "render.h"

#define OFFSET(N,F,S) \
printf ("%%define " #N " %d\n", (int) &((S *) 0)->F);

int main()
{
	OFFSET(i_RECT_left, left, RECT)
	OFFSET(i_RECT_top, top, RECT)
	OFFSET(i_RECT_right, right, RECT)
	OFFSET(i_RECT_bottom, bottom, RECT)
	OFFSET(i_SSURFACE_Surface, Surface, struct SSurface)
	OFFSET(i_SSURFACE_Pitch, Pitch, struct SSurface)
	OFFSET(i_SSURFACE_Width, Width, struct SSurface)
	OFFSET(i_SSURFACE_Height, Height, struct SSurface)
	OFFSET(i_GUI_RedShift, RedShift, struct sGUI)
	OFFSET(i_GUI_GreenShift, GreenShift, struct sGUI)
	OFFSET(i_GUI_BlueShift, BlueShift, struct sGUI)
	OFFSET(i_PPU_CGDATA, CGDATA, struct SPPU)
	OFFSET(i_IPPU_MaxBrightness, MaxBrightness, struct InternalPPU)
	return 0;
}
